﻿Imports AddinExpress.MSO
Imports System.Runtime.InteropServices
Imports System.Diagnostics
Imports System.Windows.Forms


Namespace ReplyAllInspector
    ''' <summary>
    ''' Add-in Express Outlook Item Events Class
    ''' </summary>
    Public Class ReplyAllChecker
        Inherits AddinExpress.MSO.ADXOutlookItemEvents
        Public Sub New(ByVal [module] As AddinExpress.MSO.ADXAddinModule)
            MyBase.New([module])
        End Sub

        Private Function getSubject() As String
            If Not Me.IsConnected Then
                Return "''"
            End If
            ' Get 'this.ItemObj.Subject;' via late binding
            Dim subject As Object = Me.ItemObj.GetType().InvokeMember("Subject", System.Reflection.BindingFlags.GetProperty, Nothing, Me.ItemObj, Nothing).ToString()
            If subject IsNot Nothing Then
                Return "'" & subject.ToString() & "'"
            Else
                Return "''"
            End If
        End Function

        Public Overrides Sub ProcessReply(ByVal response As Object, ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            Debug.Print("ProcessReply. The Reply event of the item with the subject " & getSubject() & " has occurred.")
            If TypeOf Me.ItemObj Is Outlook.MailItem Then
                Dim mail As Outlook.MailItem = TryCast(Me.ItemObj, Outlook.MailItem)
                If mail IsNot Nothing Then
                    Dim recipients As Outlook.Recipients = mail.Recipients
                    If recipients.Count > 1 Then
                        If MessageBox.Show("Did you mean to click 'Reply All' ?", Me.Module.AddinName + " sample project", MessageBoxButtons.YesNo) = DialogResult.Yes Then
                            Debug.Print("The Reply action is cancelled by the user.")
                            e.Cancel = True
                        End If
                    End If
                    Marshal.ReleaseComObject(recipients)
                End If
            End If
        End Sub

#Region "non-used code"

        Public Overrides Sub ProcessAttachmentAdd(ByVal attachment As Object)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessAttachmentRead(ByVal attachment As Object)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessBeforeAttachmentSave(ByVal attachment As Object, ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessBeforeCheckNames(ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessClose(ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessCustomAction(ByVal action As Object, ByVal response As Object, ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessCustomPropertyChange(ByVal name As String)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessForward(ByVal forward As Object, ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessOpen(ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessPropertyChange(ByVal name As String)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessRead()
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessReplyAll(ByVal response As Object, ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessSend(ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessWrite(ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessBeforeDelete(ByVal item As Object, ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessAttachmentRemove(ByVal attachment As Object)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessBeforeAttachmentAdd(ByVal attachment As Object, ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessBeforeAttachmentPreview(ByVal attachment As Object, ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessBeforeAttachmentRead(ByVal attachment As Object, ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessBeforeAttachmentWriteToTempFile(ByVal attachment As Object, ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessUnload()
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessBeforeAutoSave(ByVal e As AddinExpress.MSO.ADXCancelEventArgs)
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessBeforeRead()
            ' TODO: Add some code
        End Sub

        Public Overrides Sub ProcessAfterWrite()
            ' TODO: Add some code
        End Sub

#End Region

    End Class
End Namespace

